#include <iostream>
using std::cout;
using std::endl;

#include <iomanip>
using std::setw;

double polynom(double a, double b, double x)
{
   return a*x + b;
}

double polynom(double a, double b, double c, double x)
{
   return (a*x + b)*x + c;
}

double polynom(double a, double b, double c, double d, double x)
{
   return ((a*x + b)*x + c)*x + d;
}

double polynom(double a, double b, double c, double d, double e, double x)
{
   return (((a*x + b)*x + c)*x + d)*x + e;
}

int main()
{
	/* 
	 * watch out: if you're going to write the arguments as fractions, you
	 *            have to use -1.0/8 and -1.0/2 rather than -1/8 and -1/2
	 *            (each of which evaluates to integer zero)
	 */

	for (double x = -15.0; x < 15.05; x += 0.1)
		cout << setw(20) << x << setw(20) << polynom(1,2,3,x) << setw(20) << polynom(-0.125,-0.5,0,1,2,x) << endl;
	
	/* 
	 * Better yet, integerize the loop:
	 *
	 * for (int n = -150; n <= 150; ++n)
	 * {
	 *     const double x = n/10.0;
	 *     cout << setw(20) << x << setw(20) << polynom(1,2,3,x) << setw(20) << polynom(-0.125,-0.5,0,1,2,x) << endl;
	 * }
	 *
	 */

	return 0;
}
