#include <cassert>

#include <iostream>
using std::cout;
using std::endl;

#include <iomanip>
using std::setw;

#include <cmath>
using std::sqrt;

bool is_perfect_square(unsigned long int n2)
{
	unsigned long int n = (unsigned long int)sqrt((double) n2);
	if (n*n == n2) return true;
	if (n > 0 and (n-1)*(n-1) == n2) return true;
	if ((n+1)*(n+1) == n2) return true;
	return false;
}

bool is_perfect_square2(unsigned long int n2)
{
	unsigned long int n = 0;
	while (true)
	{
		const unsigned long int n_sqr = n*n;
		if (n_sqr == n2) return true;
		if (n_sqr > n2) return false;
		++n;
	}
}

int main()
{
	for (int N = 0; N < 100; ++N)
	{
		unsigned long int num_quad = 0;
		unsigned long int num_perf = 0;
		for (int i = 0; i <= N; ++i)
			for (int j = 0; j <= i; ++j)
				for (int k = 0; k <= j; ++k)
					for (int l = 0; l <= k; ++l)
					{
						++num_quad;
						unsigned long int sum_sqr = i*i+j*j+k*k+l*l;
						assert(is_perfect_square(sum_sqr) == is_perfect_square2(sum_sqr));
						if (is_perfect_square(sum_sqr)) ++num_perf;
					}
		cout << setw(6) << N << setw(12) << num_quad << setw(12) << num_perf << endl;
		
	}
	return 0;
}
