set fit errorvariables

f(x) = f0 + f1*x + f2*x**2 + f3*x**3
g(x) = g0 + g1*x + g2*x**2 + g3*x**3 + g4*x**4

fit f(x) "quad.dat" using 1:3 via f0,f1,f2,f3
fit g(x) "quad.dat" using 1:3 via g0,g1,g2,g3,g4

set xlabel "N"
set ylabel "number of perfect squares"
set logscale y
plot "quad.dat" using 1:3 title "exact", f(x), g(x)
